HDU 4496 D-City (并查集)

来源:互联网 发布:淘宝注册账号打电话 编辑:程序博客网 时间:2024/06/17 04:02

D-City

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65535/65535 K (Java/Others)
Total Submission(s): 3267    Accepted Submission(s): 1166


Problem Description
Luxer is a really bad guy. He destroys everything he met.
One day Luxer went to D-city. D-city has N D-points and M D-lines. Each D-line connects exactly two D-points. Luxer will destroy all the D-lines. The mayor of D-city wants to know how many connected blocks of D-city left after Luxer destroying the first K D-lines in the input.
Two points are in the same connected blocks if and only if they connect to each other directly or indirectly.
 

Input
First line of the input contains two integers N and M.
Then following M lines each containing 2 space-separated integers u and v, which denotes an D-line.
Constraints:
0 < N <= 10000
0 < M <= 100000
0 <= u, v < N.
 

Output
Output M lines, the ith line is the answer after deleting the first i edges in the input.
 

Sample Input
5 10 0 1 1 2 1 3 1 4 0 2 2 3 0 4 0 3 3 4 2 4
 

Sample Output
1 1 1 2 2 2 2 3 4 5
Hint
The graph given in sample input is a complete graph, that each pair of vertex has an edge connecting them, so there's only 1 connected block at first. The first 3 lines of output are 1s because after deleting the first 3 edges of the graph, all vertexes still connected together. But after deleting the first 4 edges of the graph, vertex 1 will be disconnected with other vertex, and it became an independent connected block. Continue deleting edges the disconnected blocks increased and finally it will became the number of vertex, so the last output should always be N.
 

Source
2013 ACM-ICPC吉林通化全国邀请赛——题目重现

大体题意:
告诉你有n 个城市和m 个边,每个边都连接两个城市,luxer要破坏城市每一条边,问破坏了第i 条边后,剩下的城市还有几个连通。
思路:
(其实这就是CCCC决赛的红色警报题目,亏了补了补= = !!)
因为这个人要破坏所有的边,所以到最后,一定是n 个联通块,所有我们可以倒着进行并查集。倒着并查集,lef表示剩余的连通,最后肯定n 个,破坏边相当于加边,当两个端点父结点不同时lef--,最后输出lef即可!
有坑啊:是多组数据!
详细见代码:
#include<cstdio>#include<cstring>#include<cctype>#include<cstdlib>#include<cmath>#include<iostream>#include<sstream>#include<iterator>#include<algorithm>#include<string>#include<vector>#include<set>#include<map>#include<deque>#include<queue>#include<stack>#include<list>typedef long long ll;typedef unsigned long long llu;const int maxn = 100000 + 10;const int inf = 0x3f3f3f3f;const double pi = acos(-1.0);const double eps = 1e-8;using namespace std;int fa[maxn];int e1[maxn*10];int e2[maxn*10];int find(int x){    return fa[x] == x ? x : fa[x] = find(fa[x]);}int ans[maxn*10];int main(){    int n,m;    while(scanf("%d %d",&n,&m) == 2){        for (int i = 0; i <= n; ++i)fa[i] =i;        for (int i = 0; i < m; ++i){            scanf("%d %d",&e1[i],&e2[i]);        }        int lef = n;        for (int i = m-1; i >= 0; --i){            ans[i] = lef;            int root1 = find(e1[i]);            int root2 = find(e2[i]);            if (root1 != root2){                --lef;                fa[root1 ] = root2;            }        }        for (int i = 0; i < m ; ++i)printf("%d\n",ans[i]);    }    return 0;}



 
0 0
原创粉丝点击